using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Systems.Software;

[Route(Navigation.Management.Hosts.Systems.Software.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostApplicationEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Software｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Software", href: "#", true));
    }

    private async Task<TableData<HostApplicationEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostApplicationEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostApplicationEntity>.Filter.Regex(x => x.Company, regex) |
                    Builders<HostApplicationEntity>.Filter.Regex(x => x.Name, regex) |
                    Builders<HostApplicationEntity>.Filter.Regex(x => x.Architecture, regex) |
                    Builders<HostApplicationEntity>.Filter.Regex(x => x.Version, regex) |
                    Builders<HostApplicationEntity>.Filter.Regex(x => x.InstallDate, regex);
            }

            var query = Database.HostApplication()
                .Find(filter)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Company" => Builders<HostApplicationEntity>.Sort.Ascending(p => p.Company),
                        "Name" => Builders<HostApplicationEntity>.Sort.Ascending(p => p.Name),
                        "Architecture" => Builders<HostApplicationEntity>.Sort.Ascending(p => p.Architecture),
                        "Version" => Builders<HostApplicationEntity>.Sort.Ascending(p => p.Version),
                        "InstallDate" => Builders<HostApplicationEntity>.Sort.Ascending(p => p.InstallDate),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Company" => Builders<HostApplicationEntity>.Sort.Descending(p => p.Company),
                        "Name" => Builders<HostApplicationEntity>.Sort.Descending(p => p.Name),
                        "Architecture" => Builders<HostApplicationEntity>.Sort.Descending(p => p.Architecture),
                        "Version" => Builders<HostApplicationEntity>.Sort.Descending(p => p.Version),
                        "InstallDate" => Builders<HostApplicationEntity>.Sort.Descending(p => p.InstallDate),
                        _ => null
                    },
                    _ => Builders<HostApplicationEntity>.Sort.Ascending(p => p.Name)
                });

            return new TableData<HostApplicationEntity>()
            {
                TotalItems = (int)await query.CountDocumentsAsync(default),
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostApplicationEntity>();
        }
    }
}